import type { AllowedComponentProps } from 'vue';
import type { ComponentCustomProps } from 'vue';
import type { ComponentOptionsMixin } from 'vue';
import type { DefineComponent } from 'vue';
import type { ExtractPropTypes } from 'vue';
import type { PropType } from 'vue';
import { ReplStore } from '@liting-yes/vue-repl';
import type { Store } from '@liting-yes/vue-repl';
import type { VNodeProps } from 'vue';

declare interface Props {
    store?: Store;
    autoResize?: boolean;
    clearConsole?: boolean;
    ssr?: boolean;
    code?: string;
    encode?: boolean;
    collapse?: boolean;
    previewBodyStyle?: Partial<CSSStyleDeclaration> | string;
    previewAppStyle?: Partial<CSSStyleDeclaration> | string;
    previewOptions?: {
        headHTML?: string;
        bodyHTML?: string;
        customCode?: {
            importCode?: string;
            useCode?: string;
        };
    };
}

export declare const VuePreview: DefineComponent<{
    store: {
        type: PropType<Store | undefined>;
        required: false;
        default: () => ReplStore;
    };
    autoResize: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    clearConsole: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    ssr: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    code: {
        type: PropType<string | undefined>;
        required: false;
    };
    encode: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    collapse: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    previewBodyStyle: {
        type: PropType<string | Partial<CSSStyleDeclaration> | undefined>;
        required: false;
    };
    previewAppStyle: {
        type: PropType<string | Partial<CSSStyleDeclaration> | undefined>;
        required: false;
    };
    previewOptions: {
        type: PropType<{
            headHTML?: string;
            bodyHTML?: string;
            customCode?: {
                importCode?: string;
                useCode?: string;
            };
        } | undefined>;
        required: false;
        default: () => {
            headHTML: string;
            bodyHTML: string;
            customCode: {
                importCode: string;
                useCode: string;
            };
        };
    };
}, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    store: {
        type: PropType<Store | undefined>;
        required: false;
        default: () => ReplStore;
    };
    autoResize: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    clearConsole: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    ssr: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    code: {
        type: PropType<string | undefined>;
        required: false;
    };
    encode: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    collapse: {
        type: PropType<boolean | undefined>;
        required: false;
        default: boolean;
    };
    previewBodyStyle: {
        type: PropType<string | Partial<CSSStyleDeclaration> | undefined>;
        required: false;
    };
    previewAppStyle: {
        type: PropType<string | Partial<CSSStyleDeclaration> | undefined>;
        required: false;
    };
    previewOptions: {
        type: PropType<{
            headHTML?: string;
            bodyHTML?: string;
            customCode?: {
                importCode?: string;
                useCode?: string;
            };
        } | undefined>;
        required: false;
        default: () => {
            headHTML: string;
            bodyHTML: string;
            customCode: {
                importCode: string;
                useCode: string;
            };
        };
    };
}>>, {
    store: Store | undefined;
    autoResize: boolean | undefined;
    clearConsole: boolean | undefined;
    ssr: boolean | undefined;
    encode: boolean | undefined;
    collapse: boolean | undefined;
    previewOptions: {
        headHTML?: string;
        bodyHTML?: string;
        customCode?: {
            importCode?: string;
            useCode?: string;
        };
    } | undefined;
}>;

declare function vuePreviewPlugin(options?: VuePreviewPluginOptions): {
    name: string;
    transform(code: string, id: string): string;
};
export default vuePreviewPlugin;
export { vuePreviewPlugin }

declare interface VuePreviewPluginOptions {
    props?: {
        previewBodyStyle?: Props['previewBodyStyle'];
        previewAppStyle?: Props['previewAppStyle'];
    };
}

export { }
